// JavaScript Document

var bW;
var bH;

var cW;
var cH;

//3D設定要素
var scene;
var camera;
var renderer;
var controls;
var projector;

//テキスト
var textArray;
//線
var lineArray;

//面と線の
var lineID;

//刻み幅
var stepSize;

var span;

var dFlag;

var browse;

var rotFlag;

//線のマテリアル
var lm0;
var lm1;

//テキストのマテリアル
var tm;

//ベクトルのマテリアル
var vm;

//面のマテリアル
var pm;

//点のマテリアル
var sm;

var obj;

//点P
var sP;

//三角形
var tBDE;

//点のテキスト
var tA;
var tB;
var tC;
var tD;
var tE;
var tF;
var tG;
var tH;
var tP;

//ベクトル
var vAB;
var vAD;
var vAE;

//線
var lAG;

function loadContentHandler()
{
	try
	{
		mFlag = false;
		rotFlag = true;
		var ua = navigator.userAgent;
		var eventStr = "mousedown";
		
		//スマートフォン
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			mFlag = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			mFlag = true;
		}
		
		/**注意**
		
		コンテンツの3軸表示の座標と教科書の図の座標の
		軸の方向が違っています。
		教科書の+x軸　→　+z軸
		教科書の+y軸　→　+x軸
		教科書の+z軸　→　+y軸
		****/
		
		//軸の数値1あたりのサイズ
		span = 5;
		
		stepSize = 1;
		
		var menuSize = 240;
		
		bW = pageWidth-52-menuSize;
		bH = pageHeight;
		
		cW = bW;
		cH = bH;
		
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		document.getElementById("graphBlock").style.left = menuSize + "px";
		
		$("#menuClose").css("display", "none");
		$("#configBlock").css("display", "none");
		
		animeFlag = false;
		dFlag = true;
		
		$("#check0").prop("checked", true);
		$("#check1").prop("checked", true);
		$("#check2").prop("checked", true);
		$("#check3").prop("checked", false);
		$("#check4").prop("checked", false);
		$("#check5").prop("checked", false);
		
		$("#result1").css("display", "none");
		$("#result2").css("display", "none");
		
		document.getElementById("openBtn1").addEventListener("click", openResultHandler);
		document.getElementById("openBtn2").addEventListener("click", openResultHandler);
		
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		document.getElementById("check4").addEventListener("change", changeCheckHandler);
		document.getElementById("check5").addEventListener("change", changeCheckHandler);
		
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		
		$(".configText").css("width", "30px");
		$(".configText").css("text-align", "center");
		
		init3d();
		
		changeObjectDisplay();
		
		setMenuMode(0, menuSize);
		
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function init3d()
{
	try
	{
		selectObj = "";
		
		rotFlag = true;
		
		//3Dの設定
		scene = new THREE.Scene();
		
		if(navigator.userAgent.indexOf("Chrome") != -1)
		{
			renderer = new THREE.WebGLRenderer({antialias: false});
		}
		else
		{
			renderer = new THREE.WebGLRenderer({antialias: true});
		}
		
		var dis = 16;
		
		renderer.setSize(cW, cH);
		renderer.setClearColor( new THREE.Color(0xFFFFFF) );
		
		camera = new THREE.OrthographicCamera (-cW/dis, cW/dis, cH/dis, -cH/dis, -500, 1000);
		
		controls = new THREE.OrbitControls(camera, renderer.domElement);
		projector = new THREE.Projector();
		
		camera.position.x = 20;
		camera.position.y = 30;
		camera.position.z = 100;
		
		document.getElementById("graphBlock").appendChild(renderer.domElement);
		
		//線のマテリアル
		lm0 =  new THREE.MeshBasicMaterial({color:"#000000", opacity:1, transparent:false});
		lm1 =  new THREE.MeshBasicMaterial({color:"#007700", opacity:1, transparent:false});
		
		//各面のマテリアル
		pm = new THREE.MeshBasicMaterial({color:0xEBF3D8, opacity:0.5, transparent:true});
		pm.side = THREE.DoubleSide;
		
		//ベクトルのマテリアル
		vm = new THREE.MeshBasicMaterial({color:"#000000", opacity:1, transparent:false});
		
		//点のマテリアル
		sm = new THREE.MeshBasicMaterial( { color: "#007AC5", opacity:1, transparent:true} );
		
		//テキストのマテリアル
		tm = new THREE.MeshBasicMaterial({color:"#000000", opacity:1, transparent:false})
		
		//3D内のテキスト
		textArray = [];
		//各辺のオブジェクト
		lineArray = [];
		//各点のオブジェクト
		pointArray = [];
		
		obj = new THREE.Object3D();
		obj.renderOrder = 10;
		scene.add(obj);
		
		//座標のデータ
		var pArray = [];
		pArray[0] = {x:-5, y:1.5, z:2.5};
		pArray[1] = {x:2, y:1.5, z:2.5};
		pArray[2] = {x:5, y:1.5, z:-2.5};
		pArray[3] = {x:-2, y:1.5, z:-2.5};
		
		pArray[4] = {x:-6, y:-1.5, z:4.5};
		pArray[5] = {x:1, y:-1.5, z:4.5};
		pArray[6] = {x:4, y:-1.5, z:-0.5};
		pArray[7] = {x:-3, y:-1.5, z:-0.5};
		
		for(var i=0; i<=7; i++)
		{
			pArray[i].x = pArray[i].x * span;
			pArray[i].y = pArray[i].y * span;
			pArray[i].z = pArray[i].z * span;
		}
		
		pArray[8] = {x:0, y:0, z:0};
		pArray[8].x =  (pArray[1].x+pArray[3].x+pArray[4].x)/3;
		pArray[8].y = (pArray[1].y+pArray[3].y+pArray[4].y)/3;
		pArray[8].z = (pArray[1].z+pArray[3].z+pArray[4].z)/3;
		
		//頂点のテキスト
		tA = createTextMesh("A", 3, tm);
		tB = createTextMesh("B", 3, tm);
		tC = createTextMesh("C", 3, tm);
		tD = createTextMesh("D", 3, tm);
		tE = createTextMesh("E", 3, tm);
		tF = createTextMesh("F", 3, tm);
		tG = createTextMesh("G", 3, tm);
		tH = createTextMesh("H", 3, tm);
		tP = createTextMesh("P", 3, tm);
		
		obj.add(tA);
		obj.add(tD);
		obj.add(tB);
		obj.add(tC);
		obj.add(tD);
		obj.add(tE);
		obj.add(tF);
		obj.add(tG);
		obj.add(tH);
		obj.add(tP);
		
		textArray.push(tA);
		textArray.push(tB);
		textArray.push(tC);
		textArray.push(tD);
		textArray.push(tE);
		textArray.push(tF);
		textArray.push(tG);
		textArray.push(tH);
		textArray.push(tP);
		
		var tSpan0 = 3.5;
		var tSpan1 = 1.5;
		
		for(var i=0; i<=7; i++)
		{
			if(i%4 == 0 || i%4 == 3)
			{
				textArray[i].position.x = pArray[i].x - tSpan0;
			}
			else
			{
				textArray[i].position.x = pArray[i].x + tSpan1;
			}
			
			if(i/4 < 1)
			{
				textArray[i].position.y = pArray[i].y + tSpan1;
			}
			else
			{
				textArray[i].position.y = pArray[i].y - tSpan0;
			}
			
			textArray[i].position.z = pArray[i].z;
		}
		
		tP.position.x = pArray[8].x-tSpan1;
		tP.position.y = pArray[8].y+tSpan1;
		tP.position.z = pArray[8].z;
		
		//各辺の作成
		for(var i=0; i<4; i++)
		{
			if(i < 3)
			{
				lineArray[i] = createLineCylinder(pArray[i], pArray[i+1], 0.15, lm0);
				lineArray[i+4] = createLineCylinder(pArray[i+4], pArray[i+5], 0.15, lm0);}
			else
			{
				lineArray[i] = createLineCylinder(pArray[3], pArray[0], 0.15, lm0);
				lineArray[i+4] = createLineCylinder(pArray[7], pArray[4], 0.15, lm0);
			}
			
			lineArray[i+8] = createLineCylinder(pArray[i], pArray[i+4], 0.15, lm0);
			
			obj.add(lineArray[i]);
			obj.add(lineArray[i+4]);
			obj.add(lineArray[i+8]);
		}
		
		//点P
		sg = new THREE.SphereGeometry(0.75);
		sP = new THREE.Mesh(sg, sm);
		obj.add(sP);
		
		sP.position.x = pArray[8].x;
		sP.position.y = pArray[8].y;
		sP.position.z = pArray[8].z;
		
		//三角形BDE
		tBDE = new THREE.Object3D();
		//三角形の面
		var tPoints = [
			new THREE.Vector3(pArray[1].x, pArray[1].y, pArray[1].z),
			new THREE.Vector3(pArray[3].x, pArray[3].y, pArray[3].z),
			new THREE.Vector3(pArray[4].x, pArray[4].y, pArray[4].z)];
		
		var triangle = new THREE.Mesh(new THREE.ConvexGeometry(tPoints), pm);
		
		tBDE.add(triangle);
		
		var line0 = createLineCylinder(pArray[1], pArray[3], 0.1, lm0);
		var line1 = createLineCylinder(pArray[1], pArray[4], 0.1, lm0);
		var line2 = createLineCylinder(pArray[3], pArray[4], 0.1, lm0);
		
		tBDE.add(line0);
		tBDE.add(line1);
		tBDE.add(line2);
		
		obj.add(tBDE);
		
		
		//各ベクトル
		vAB = createArrowObject(pArray[0], pArray[1], 0.2, 0.6 * 1.5, 3 * 1.5, vm);
		vAD = createArrowObject(pArray[0], pArray[3], 0.2, 0.6 * 1.5, 3 * 1.5, vm);
		vAE = createArrowObject(pArray[0], pArray[4], 0.2, 0.6 * 1.5, 3 * 1.5, vm);
		
		obj.add(vAB);
		obj.add(vAD);
		obj.add(vAE);
		
		vAB.position.x = pArray[0].x;
		vAB.position.y = pArray[0].y;
		vAB.position.z = pArray[0].z;
		
		vAD.position.x = pArray[0].x;
		vAD.position.y = pArray[0].y;
		vAD.position.z = pArray[0].z;
		
		vAE.position.x = pArray[0].x;
		vAE.position.y = pArray[0].y;
		vAE.position.z = pArray[0].z;
		
		lAG = createLineCylinder(pArray[0], pArray[6], 0.2, lm1);
		obj.add(lAG);
		
		render();
	}
	catch(e)
	{
		alert("init:" + e.toString());
	}
}


function render()
{
	try
	{
	
		requestAnimationFrame(render);
		
		controls.update();
		
		for(var i=0; i<textArray.length; i++)
		{
			textArray[i].rotation.setFromRotationMatrix( camera.matrix );
		}
		
		renderer.render(scene, camera);
	}
	catch(e)
	{
		alert("render:" + e.toString());
	}
}

function openResultHandler(e)
{
	try
	{
		if(e.currentTarget.id == "openBtn1")
		{
			if($("#result1").css("display") == "none")
			{
				$("#result1").css("display", "block");
			}
			else
			{
				$("#result1").css("display", "none");
			}
		}
		else
		{
			if($("#result2").css("display") == "none")
			{
				$("#result2").css("display", "block");
			}
			else
			{
				$("#result2").css("display", "none");
			}
		}
	}
	catch(e)
	{
		alert("openResultHandler:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		changeObjectDisplay();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

function changeObjectDisplay()
{
	try
	{
		var f = $("#check0").prop("checked");
		tBDE.visible = f;
		
		f = $("#check1").prop("checked");
		sP.visible = f;
		tP.visible = f;
		
		f = $("#check2").prop("checked");
		lAG.visible = f;
		
		f = $("#check3").prop("checked");
		vAB.visible = f;
		
		f = $("#check4").prop("checked");
		vAD.visible = f;
		
		f = $("#check5").prop("checked");
		vAE.visible = f;
	}
	catch(e)
	{
		alert("changeObjectDisplay:" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = camera.position.x;
		array[0][1] = camera.position.y;
		array[0][2] = camera.position.z;
		array[0][3] = controls.object.zoom;
		
		array[1] = [];
		array[1][0] = $("#check0").prop("checked");
		array[1][1] = $("#check1").prop("checked");
		array[1][2] = $("#check2").prop("checked");
		array[1][3] = $("#check3").prop("checked");
		array[1][4] = $("#check4").prop("checked");
		array[1][5] = $("#check5").prop("checked");
		
		array[2] = [];
		array[2][0] = $("#result1").css("display");
		array[2][1] = $("#result2").css("display");
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		camera.position.x = array[0][0];
		camera.position.y = array[0][1];
		camera.position.z = array[0][2];
		controls.object.zoom = array[0][3];
		controls.object.updateProjectionMatrix();
		
		$("#check0").prop("checked", array[1][0]);
		$("#check1").prop("checked", array[1][1]);
		$("#check2").prop("checked", array[1][2]);
		$("#check3").prop("checked", array[1][3]);
		$("#check4").prop("checked", array[1][4]);
		$("#check5").prop("checked", array[1][5]);
		
		$("#result1").css("display", array[2][0]);
		$("#result2").css("display", array[2][1]);
		
		changeObjectDisplay();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			camera.position.x = 50;
			camera.position.y = 30;
			camera.position.z = 100;
			controls.object.zoom = 1;
			controls.object.updateProjectionMatrix();
			
			$("#check0").prop("checked", true);
			$("#check1").prop("checked", true);
			$("#check2").prop("checked", true);
			$("#check3").prop("checked", false);
			$("#check4").prop("checked", false);
			$("#check5").prop("checked", false);
			
			$("#result1").css("display", "none");
			$("#result2").css("display", "none");
			
			changeObjectDisplay();
		}
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
