// JavaScript Document
selectData = function(balloon, id, data, fnc)
{
	this.balloon = balloon;
	this.id = id;
	this.data = data.slice();
	this.fnc = fnc;
}

selectData.prototype.getID = function()
{
	return this.id;
}


var selectBalloon = null;

function openSelectBalloon(balloonID, baseID, id, inner, data, fnc, p)
{
	try
	{
		/*
		balloonID：開くselectBalloonのID
		baseID：基準座標になる親要素のID
		id:開くときに押した対象のID
		inner:選択項目のinnerHTMLに入れるデータのID
		data:選択時に返す値
		fnc:選択時に実行する関数
		*/
		
		if(selectBalloon != null && selectBalloon.id == id && document.getElementById(balloonID).style.display == "inline-block")
		{
			closeSelectBalloon();
		}
		else
		{
			//別の項目選択が開いている場合
			if(selectBalloon != null && selectBalloon.id != id)
			{
				closeSelectBalloon();
			}
			
			
			var balloon = $("#"+balloonID);
			var target = $("#"+id);
			var base = $("#"+baseID);
			var block = document.getElementById(balloonID+"_block");
			var child =  $("#"+balloonID+"_block").childNodes;
			
			//前の項目を削除
			while(block.childElementCount > 0)
			{
				block.firstChild.removeEventListener("click", selectBalloonItemHandler);
				block.removeChild(block.firstChild);
			}
			
			//項目を格納する
			for(var i=0; i<inner.length; i++)
			{
				var elm = document.createElement("div");
				elm.setAttribute("class", "selectBalloonItem");
				elm.setAttribute("id", balloonID+"Item_"+i);
				elm.innerHTML = inner[i];
				block.appendChild(elm);
				
				elm.addEventListener("click", selectBalloonItemHandler);
			}
			
			balloon.css("display", "inline-block");
			
			var eX;
			var eY;
			var tX = target.offset().left;
			var tY = target.offset().top;
			var bX = base.offset().left;
			var bY = base.offset().top;
			var tW = target.innerWidth();
			var tH = target.innerHeight();
			
			if(baseID == "configBalloon")
			{
				balloon.css("right", bX-tX+5);
				balloon.css("bottom", bY-tY-tH-5);
			}
			else
			{
				balloon.css("left", tX-bX+tW+5);
				
				//下揃え
				if(p == null || p == undefined || p == 0)
				{
					balloon.css("top", tY-bY-balloon.outerHeight()+tH);	
				}
				//中央揃え
				else if(p == 1)
				{
					balloon.css("top", tY-bY-balloon.outerHeight()/2+5);
					$("#selectBalloon_menu svg").css("top", balloon.outerHeight()/2+"px");
				}
				//上揃え
				else
				{
					balloon.css("top", tY-bY-5);
					$("#selectBalloon_menu svg").css("top", "10px");
				}
			}
			
			selectBalloon = new selectData(balloonID, id, data, fnc);
		}
	}
	catch(e)
	{
		alert("openSelectBalloon:"+e.toString());
	}
}

function closeSelectBalloon()
{
	try
	{
		if(selectBalloon != null)
		{
			document.getElementById(selectBalloon.balloon).style.display = "none";
			selectBalloon = null;
		}
	}
	catch(e)
	{
		alert("closeSelectBalloon:" + e.toString());
	}
}

function selectBalloonItemHandler(e)
{
	try
	{
		//選択した項目番号
		var str= e.currentTarget.id;
		str = str.substring(str.lastIndexOf("_")+1, str.length);
		
		var n = parseInt(str);
		
		document.getElementById(selectBalloon.id).innerHTML = e.currentTarget.innerHTML;
		
		//選択したオブジェクトのIDと選択したデータを実行関数に渡す
		selectBalloon.fnc(selectBalloon.id, selectBalloon.data[n]);
		
		closeSelectBalloon();
	}
	catch(e)
	{
		alert("selectBalloonItemHandler:" + e.toString());
	}
}